/*
 * generated by Xtext
 */
package org.openxma.dsl.pom.scoping;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.xtext.EcoreUtil2;
import org.eclipse.xtext.naming.IQualifiedNameProvider;
import org.eclipse.xtext.scoping.IScope;
import org.eclipse.xtext.scoping.Scopes;
import org.eclipse.xtext.scoping.impl.SimpleScope;
import org.openxma.dsl.common.Strings;
import org.openxma.dsl.core.model.ReferenceableByXmadslVariable;
import org.openxma.dsl.core.model.Type;
import org.openxma.dsl.core.model.XmadslVariable;
import org.openxma.dsl.core.scoping.CoreDslScopeProvider;
import org.openxma.dsl.dom.model.Attribute;
import org.openxma.dsl.dom.model.ComplexType;
import org.openxma.dsl.dom.model.DelegateOperation;
import org.openxma.dsl.dom.model.Operation;
import org.openxma.dsl.dom.model.PresentableFeature;
import org.openxma.dsl.dom.model.Service;
import org.openxma.dsl.dom.naming.DomNameFunction;
import org.openxma.dsl.pom.PomPackage;
import org.openxma.dsl.pom.model.AbsoluteSiblingAttachment;
import org.openxma.dsl.pom.model.AttachmentPosition;
import org.openxma.dsl.pom.model.AttachmentProperty;
import org.openxma.dsl.pom.model.Button;
import org.openxma.dsl.pom.model.ColumnInfo;
import org.openxma.dsl.pom.model.Command;
import org.openxma.dsl.pom.model.Component;
import org.openxma.dsl.pom.model.ComposeData;
import org.openxma.dsl.pom.model.Composite;
import org.openxma.dsl.pom.model.CustomizationOfComposite;
import org.openxma.dsl.pom.model.CustomizationOfGuiElement;
import org.openxma.dsl.pom.model.DataMapping;
import org.openxma.dsl.pom.model.DataObjectVariable;
import org.openxma.dsl.pom.model.EventFunction;
import org.openxma.dsl.pom.model.ExecuteStatement;
import org.openxma.dsl.pom.model.FieldFeature;
import org.openxma.dsl.pom.model.GuiElement;
import org.openxma.dsl.pom.model.GuiElementEventMapping;
import org.openxma.dsl.pom.model.IComposite;
import org.openxma.dsl.pom.model.IElementWithLayoutData;
import org.openxma.dsl.pom.model.IField;
import org.openxma.dsl.pom.model.IReferenceableByStatementVariable;
import org.openxma.dsl.pom.model.Image;
import org.openxma.dsl.pom.model.ImageUri;
import org.openxma.dsl.pom.model.InvokeStatement;
import org.openxma.dsl.pom.model.Label;
import org.openxma.dsl.pom.model.LabelText;
import org.openxma.dsl.pom.model.LogicItem;
import org.openxma.dsl.pom.model.ObjectProperty;
import org.openxma.dsl.pom.model.Page;
import org.openxma.dsl.pom.model.PropertyJoin;
import org.openxma.dsl.pom.model.Proxy;
import org.openxma.dsl.pom.model.ReferencedXMAComposite;
import org.openxma.dsl.pom.model.ReferencedXMAPage;
import org.openxma.dsl.pom.model.SetOfGuiElements;
import org.openxma.dsl.pom.model.SiblingAttachment;
import org.openxma.dsl.pom.model.StatementVariable;
import org.openxma.dsl.pom.model.StringDefinition;
import org.openxma.dsl.pom.model.TabFolder;
import org.openxma.dsl.pom.model.TabSetting;
import org.openxma.dsl.pom.model.Table;
import org.openxma.dsl.pom.model.TableColumn;
import org.openxma.dsl.pom.model.TabulatorPosition;
import org.openxma.dsl.pom.model.XMAWidgetEventMapping;
import org.openxma.dsl.pom.model.XmaVariable;
import org.openxma.dsl.pom.model.XmadslComposite;
import org.openxma.dsl.pom.model.XmadslPage;
import org.openxma.dsl.pom.naming.CustomPomDslNameProvider;
import org.openxma.dsl.pom.naming.GuiDesignNameFunction;
import org.openxma.dsl.pom.util.LayoutData;
import org.openxma.dsl.pom.validation.PomDslJavaValidator;

import at.spardat.xma.guidesign.XMACompProperty;
import at.spardat.xma.guidesign.XMAComponent;
import at.spardat.xma.guidesign.XMAComposite;
import at.spardat.xma.guidesign.XMAPage;
import at.spardat.xma.guidesign.flex.IExpVariable;

import com.google.inject.Inject;

/**
 * This class contains custom scoping description.
 * 
 * see : http://www.eclipse.org/Xtext/documentation/latest/xtext.html#scoping on
 * how and when to use it
 * 
 */
public class PomDslScopeProvider extends CoreDslScopeProvider {
	@Inject 
	IQualifiedNameProvider qualifiedNameProvider;				

	@Inject 
	GuiDesignNameFunction guiDesignNameFunction;
	
	@Inject
	DomNameFunction domNameFunction;
	
	@Inject
	CustomPomDslNameProvider customPomDslNameProvider;
	
	
	public IScope scope_CustomizationOfComposite_composite(CustomizationOfComposite customizationOfComposite,
			EReference eReference) {
		List<IComposite> eAllOfType = EcoreUtil2.eAllOfType(customizationOfComposite.getPage().getContent(), IComposite.class);
		return new SimpleScope(Scopes.scopedElementsFor(eAllOfType, guiDesignNameFunction));
	}
	public IScope scope_ReferencedXMAPage_xmaPage(ReferencedXMAPage referencedXMAPage,
			EReference eReference) {
		Component component = (Component) referencedXMAPage.eContainer();
		return new SimpleScope(Scopes.scopedElementsFor(component.getXmaComponent().getPage(), guiDesignNameFunction));
	}
	
	public IScope scope_ReferencedXMAComposite_xmaComposite(ReferencedXMAComposite referencedXMAComposite,
			EReference eReference) {
		ReferencedXMAPage containingPage = EcoreUtil2.getContainerOfType(referencedXMAComposite, ReferencedXMAPage.class);
		XMAPage xmaPage = containingPage.getXmaPage();
		return new SimpleScope(Scopes.scopedElementsFor(EcoreUtil2.getAllContentsOfType(xmaPage, XMAComposite.class),
				guiDesignNameFunction));
	}
	
	public IScope scope_XmaVariable_reference(XmaVariable xmaVariableRef, EReference eReference) {
		Page page = EcoreUtil2.getContainerOfType(xmaVariableRef, Page.class);
		if (page instanceof ReferencedXMAPage) {
			ReferencedXMAPage refXMAPage = (ReferencedXMAPage)page;	
			if (refXMAPage.getXmaPage() != null) {
				XMAPage xmaPage = refXMAPage.getXmaPage();		
				List<IExpVariable> elements = EcoreUtil2.getAllContentsOfType(refXMAPage.getXmaPage(),IExpVariable.class);
				elements.add(xmaPage);		
				addComponentPropertiesTo(elements,xmaPage.getComponent());					
				return new SimpleScope(Scopes.scopedElementsFor(elements,guiDesignNameFunction));
			} else {
				return super.getScope(xmaVariableRef, eReference);
			}
		} 
		Component component = EcoreUtil2.getContainerOfType(xmaVariableRef, Component.class);
		if (component != null) {
			List<IExpVariable> elements = new ArrayList<IExpVariable>();			
			addComponentPropertiesTo(elements,component.getXmaComponent());
			return new SimpleScope(Scopes.scopedElementsFor(elements,guiDesignNameFunction));	
		}
		return super.getScope(xmaVariableRef, eReference);
	}
	
	public IScope scope_XmadslVariable_reference(XmadslVariable xmadslVariableRef, EReference eReference) {	
		Page page = EcoreUtil2.getContainerOfType(xmadslVariableRef, Page.class);		
		List<ReferenceableByXmadslVariable> elements = PomElementCollector.getNSIReferenceableByXmadslVariable(page);				
		return new SimpleScope(Scopes.scopedElementsFor(elements));	
	}	
	
	public IScope scope_StatementVariable_reference(StatementVariable statementVariableRef, EReference eReference) {
		Page page = EcoreUtil2.getContainerOfType(statementVariableRef, Page.class);
		List<IReferenceableByStatementVariable> elements = PomElementCollector.getNSIReferenceableByStatementVariable(page);		
		return new SimpleScope(Scopes.scopedElementsFor(elements, customPomDslNameProvider));             		
	}
	
	public IScope scope_ExecuteStatement_service(ExecuteStatement executeStatement,EReference eReference) {
		Page page = EcoreUtil2.getContainerOfType(executeStatement, Page.class);
		Component c = PomElementCollector.getContainingComponent(page);
		List<Service> elements = EcoreUtil2.typeSelect(c.getDependencies(),Service.class);		
		if (page instanceof XmadslPage) {
			XmadslPage xmadslPage = (XmadslPage)page;
			elements.addAll(EcoreUtil2.typeSelect(xmadslPage.getDependencies(),Service.class));						
		} else if (page instanceof ReferencedXMAPage) {
			ReferencedXMAPage referencedXMAPage = (ReferencedXMAPage)page;
			elements.addAll(EcoreUtil2.typeSelect(referencedXMAPage.getDependencies(),Service.class));				
		}
		return new SimpleScope(Scopes.scopedElementsFor(elements));					
	}
	
	public IScope scope_ExecuteStatement_operation(ExecuteStatement executeStatement, EReference eReference) {
		Service service = executeStatement.getService();
		if (service != null) {
			List<Operation> elements = service.getOperations();		
			return new SimpleScope(Scopes.scopedElementsFor(elements));
		}
		return super.getScope(executeStatement, eReference);				
	}
	
	public IScope scope_ExecuteStatement_delegateOperation(ExecuteStatement executeStatement, EReference eReference) {
		Service service = executeStatement.getService();
		if (service != null) {
			List<DelegateOperation> elements = service.getDelegateOperations();		
			return new SimpleScope(Scopes.scopedElementsFor(elements));
		}
		return super.getScope(executeStatement, eReference);				
	}
	
	public IScope scope_InvokeStatement_targetPanel(InvokeStatement showStatementRef, EReference eReference) {
	    Page containingPage = EcoreUtil2.getContainerOfType(showStatementRef, Page.class);
	    List<XmadslComposite> elements = PomElementCollector.getNSXmadslComposite(containingPage);	   
	    return new SimpleScope(Scopes.scopedElementsFor(elements));	    
	}
	
	public IScope scope_InvokeStatement_pageOfInvokeAble(InvokeStatement showStatementRef, EReference eReference) {
		Component comp = null;		
		if (showStatementRef.getInvokeAble() instanceof Component) {
			comp=(Component)showStatementRef.getInvokeAble();
		} else if (showStatementRef.getInvokeAble() instanceof Page) {
			comp = EcoreUtil2.getContainerOfType(showStatementRef, Component.class);
		}
		List<Page> elements = new ArrayList<Page>();		
		if (comp != null) {
			elements = comp.getPages();					
		}
		return new SimpleScope(Scopes.scopedElementsFor(elements));
	}
	
	public IScope scope_PropertyJoin_property(PropertyJoin propertyJoin, EReference eReference) {
		InvokeStatement invokeStatement = (InvokeStatement)propertyJoin.eContainer();
		List<ObjectProperty> elements = new ArrayList<ObjectProperty>();		
		if (invokeStatement.getInvokeAble() instanceof Component) {
			Component comp=(Component)invokeStatement.getInvokeAble();
			elements = comp.getComponentProperties();
		} else if (invokeStatement.getInvokeAble() instanceof Proxy) {
			Proxy proxy=(Proxy)invokeStatement.getInvokeAble();
			elements = proxy.getProperties();
		} else if (invokeStatement.getInvokeAble() instanceof XmadslPage) {
			XmadslPage page=(XmadslPage)invokeStatement.getInvokeAble();					
			elements = page.getPageProperties();
		}
		return new SimpleScope(Scopes.scopedElementsFor(elements));
	}

	protected void addComponentPropertiesTo(List<IExpVariable> elements, XMAComponent xmaComponent) {
		Iterator propIt = xmaComponent.getProperty().iterator();
		while (propIt.hasNext()) {
			XMACompProperty prop = (XMACompProperty)propIt.next();
			elements.add(prop);				
		}		
	}
	
	public IScope scope_Image_imageUriReference(Image image, EReference eReference) {
		List<ImageUri> elements = getImageUris(image);		
		return new SimpleScope(Scopes.scopedElementsFor(elements));	
	}
	
	public IScope scope_Label_imageUriReference(Label label, EReference eReference) {
		List<ImageUri> elements = getImageUris(label);		
		return new SimpleScope(Scopes.scopedElementsFor(elements));	
	}
	
	public IScope scope_Button_imageUriReference(Button button, EReference eReference) {
		List<ImageUri> elements = getImageUris(button);		
		return new SimpleScope(Scopes.scopedElementsFor(elements));	
	}		
	
	private static List<ImageUri> getImageUris(EObject obj) {
		List<ImageUri> elements = new ArrayList<ImageUri>();		
		// Pages
		Page page = EcoreUtil2.getContainerOfType(obj, Page.class);
		Collection<Page> pages = PomElementCollector.getAccessiblePages(page);		
		for (Page ap : pages) {
			if (ap.getDefinitions() != null && ap.getDefinitions().getImageSources() != null) {
				elements.addAll(ap.getDefinitions().getImageSources());
			}
		}
		// Component
		Component c = PomElementCollector.getContainingComponent(page);
		if (c.getDefinitions() != null && c.getDefinitions().getImageSources() != null) {		
			elements.addAll(c.getDefinitions().getImageSources());
		}
		return elements;		
	}

//	public IScope scope_IField_attributeHolder(IField field, EReference eReference) {
//		List<? extends EObject> allAttributeHolders = field.getObject().getType().getAllAttributeHolders();
//		return new SimpleScope(Scopes.scopedElementsFor(allAttributeHolders, new com.google.common.base.Function<EObject, String>() {
//			public String apply(EObject eObject) {
//				if (eObject instanceof AttributeWithProperties) {
//					AttributeWithProperties attributeWithProperties = (AttributeWithProperties) eObject;
//					return attributeWithProperties.getAttributeHolder().getName();
//				}
//				return ((AttributeHolder) eObject).getName();
//			}
//		}));
//	}
	
	
	public IScope scope_IField_feature(IField field, EReference eReference) {
		
		if (field.getFeature() != null) {
			ComplexType complexType = field.getObject().getType();
			List<Attribute> allAttributeHolders = complexType.getAllAttributes();						
			return new SimpleScope(Scopes.scopedElementsFor(allAttributeHolders, new com.google.common.base.Function<Attribute, String>() {
				public String apply(Attribute eObject) {
					return eObject.getName();
				}
			}));	
		}
		return null;
	}
	
	public IScope scope_FieldFeature_feature(IField field, EReference eReference) {
		ComplexType complexType = field.getObject().getType();		
		List<PresentableFeature> allAttributeHolders = complexType.getAllPresentableFeaturesIncludingSuperType();
		return new SimpleScope(Scopes.scopedElementsFor(allAttributeHolders));			
	}	
	
	public IScope scope_FieldFeature_feature(FieldFeature fieldFeature, EReference eReference) {
		
		ComplexType complexType = null;		
		EObject container = fieldFeature.eContainer();
		if (container instanceof IField) {
			IField field = (IField)container;
			complexType = field.getObject().getType();			
		} else if (container instanceof TableColumn) {
			TableColumn tableColumn = (TableColumn)container;
			if (tableColumn.getObject() != null) {			
				complexType = tableColumn.getObject().getType();
			} else {
				Table table = (Table)tableColumn.eContainer();
				complexType = table.getObject().getType();
			}
		} else if (container instanceof FieldFeature) {
			FieldFeature ffc = (FieldFeature)container;
			PresentableFeature pf = ffc.getFeature();
			Type type = PomDslJavaValidator.getTypeOfPresentableFeature(pf);
			if (type instanceof ComplexType) {
				complexType = (ComplexType)type;
			} else {
				throw new RuntimeException("Complex type expected for FieldFeature");
			}
		}
		
		List<PresentableFeature> allAttributeHolders = complexType.getAllPresentableFeaturesIncludingSuperType();
		return new SimpleScope(Scopes.scopedElementsFor(allAttributeHolders,domNameFunction));			
	}		

	public IScope scope_IField_object(IField field, EReference eReference) {
		Page containingPage = PomElementCollector.getContainingPage(field);
		Component containgComponent = containingPage != null ? PomElementCollector.getContainingComponent(containingPage)
				: PomElementCollector.getContainingComponent(field);
		Collection<EObject> nsDataObjectVariable = getNsDataObjectVariable(containgComponent, containingPage);
		return new SimpleScope(Scopes.scopedElementsFor(nsDataObjectVariable));
	}
	
//	public IScope scope_ReferencedXMAComposite_xmaComposite(ReferencedXMAComposite referencedXMAComposite,
//			EReference eReference) {
//		ReferencedXMAPage containingPage = (ReferencedXMAPage) PomElementCollector.getContainingPage(referencedXMAComposite);
//		XMAPage xmaPage = containingPage.getXmaPage();
//		List<EObject> elementsOfPage = getNsElementsInRange(xmaPage, null);
//		return new SimpleScope(Scopes.scopedElementsFor(elementsOfPage, qualifiedNameProvider));
//	}
	
	public IScope scope_EventFunction_command(EventFunction eventFunction, EReference eReference) {
		Page containingPage = PomElementCollector.getContainingPage(eventFunction);
		Component containingComponent = PomElementCollector.getContainingComponent(eventFunction); 
		Collection<Command> commandsInScope = PomElementCollector.getInstance().getAccessibleCommands(containingPage,containingComponent);		
		return new SimpleScope(Scopes.scopedElementsFor(commandsInScope));	
	}
	
	public IScope scope_GuiElementEventMapping_control(GuiElementEventMapping guiElementEventMapping, EReference eReference) {
		Page containingPage = PomElementCollector.getContainingPage(guiElementEventMapping);		
		List<EObject> elementsOfPage = getNsElementsOfPage(containingPage);
				
		//return createSimpleScopeWithCustomNameResolving(elementsOfPage);					
		return new SimpleScope(Scopes.scopedElementsFor(elementsOfPage, customPomDslNameProvider));				
	}
	
    public IScope scope_LogicItem_guiElement(LogicItem logicItem, EReference eReference) {
        Page containingPage = PomElementCollector.getContainingPage(logicItem);        
        List<EObject> elementsOfPage = getNsElementsOfPage(containingPage);              
        return new SimpleScope(Scopes.scopedElementsFor(elementsOfPage, customPomDslNameProvider));             
    }
    
    public IScope scope_ColumnInfo_columns(ColumnInfo columnOrder, EReference eReference) {
        LogicItem containingLogicItem = (LogicItem)EcoreUtil2.getContainerOfType(columnOrder,LogicItem.class);
        Table table = (Table)containingLogicItem.getGuiElement();
        return new SimpleScope(Scopes.scopedElementsFor(table.getColumns(), customPomDslNameProvider));             
    }
    
    public IScope scope_TabSetting_orderedElements(TabSetting tabSetting, EReference eReference) {
        LogicItem containingLogicItem = (LogicItem)EcoreUtil2.getContainerOfType(tabSetting,LogicItem.class);
        Collection<EObject> elements = new ArrayList<EObject>();        
        GuiElement guiElement = containingLogicItem.getGuiElement();
        if (guiElement instanceof Composite) {
            Composite composite = (Composite)guiElement;
            elements = PomElementCollector.getAllGuiElementsOfComposite(composite);                        
        }
        return new SimpleScope(Scopes.scopedElementsFor(elements, customPomDslNameProvider));             
    }
    
    public IScope scope_TabSetting_excludedElements(TabSetting tabSetting, EReference eReference) {
        LogicItem containingLogicItem = (LogicItem)EcoreUtil2.getContainerOfType(tabSetting,LogicItem.class);
        Collection<EObject> elements = new ArrayList<EObject>();
        GuiElement guiElement = containingLogicItem.getGuiElement();        
        if (guiElement instanceof Composite) {
            Composite composite = (Composite)guiElement;
            elements = PomElementCollector.getAllGuiElementsOfComposite(composite);                        
        }
        return new SimpleScope(Scopes.scopedElementsFor(elements, customPomDslNameProvider));             
    }     
	
	public IScope scope_XMAWidgetEventMapping_control(XMAWidgetEventMapping xmaWidgetEventMapping, EReference eReference) {
		ReferencedXMAPage containingPage = (ReferencedXMAPage) PomElementCollector.getContainingPage(xmaWidgetEventMapping);
		XMAPage xmaPage = containingPage.getXmaPage();		
		List<EObject> elementsOfPage = getNsElementsInRange(xmaPage,null);
		return new SimpleScope(Scopes.scopedElementsFor(elementsOfPage));				
	}
	
	public IScope scope_LabelText_referencedLabelString(LabelText labelText, EReference eReference) {
		ReferencedXMAPage containingPage = (ReferencedXMAPage) PomElementCollector.getContainingPage(labelText);
		Collection<StringDefinition> stringDefinitionInScope = PomElementCollector.getInstance().getAccessibleStringDefinitions(containingPage);		
		return new SimpleScope(Scopes.scopedElementsFor(stringDefinitionInScope));				
	}		
	
	public IScope scope_DataMapping_control(DataMapping dataMapping, EReference eReference) {
		ReferencedXMAPage containingPage = (ReferencedXMAPage) PomElementCollector.getContainingPage(dataMapping);
		XMAPage xmaPage = containingPage.getXmaPage();		
		List<EObject> elementsOfPage = getNsElementsInRange(xmaPage, null);
		return new SimpleScope(Scopes.scopedElementsFor(elementsOfPage));				
	}
	
	public IScope scope_AbsoluteSiblingAttachment_sibling(AbsoluteSiblingAttachment siblingAttachment, EReference eReference) {

		// TimeMeasurement tm = new
		// TimeMeasurement("scope_SiblingAttachment_sibling "+siblingAttachment.getSiblingPosition());
		try {
			// tm.begin();
			LayoutData layoutData = getLayoutDataOfSiblingAttachment(siblingAttachment);
			GuiElement guiElement = (GuiElement) layoutData.getElementWithLayoutData();
			
			// GuiElement-siblings
			EObject containerOfSiblings = getContainerOfSiblings(guiElement);			
			List<EObject> siblings = getContainedGuiElements(containerOfSiblings);
			
			// TabulatorPosition siblings
			EObject containerOfComposeData = getContainerOfComposeData(guiElement);					
			if (containerOfComposeData != null) {
				ComposeData composeData = null;
				if (containerOfComposeData instanceof IComposite) {
					IComposite iComposite = (IComposite) containerOfComposeData;
					composeData = iComposite.getContent().getComposeLayout();
				}
				if (composeData != null) {
					List<TabulatorPosition> tabulators = composeData.getTabulators();
					for (TabulatorPosition tp : tabulators) {
						if (tp.getName() != null)
							siblings.add(tp);
					}
				}
			}
			// AttachementPosition siblings
			Page containingPage = PomElementCollector.getContainingPage(siblingAttachment);			
			Collection<AttachmentPosition> attachmentPositionsInScope = PomElementCollector.getInstance().getAccessibleAttachmentPositions(containingPage);
			siblings.addAll(attachmentPositionsInScope);			
			
			return new SimpleScope(Scopes.scopedElementsFor(siblings,customPomDslNameProvider));
		} finally {
			// tm.end();
		}
	}	

	public IScope scope_SiblingAttachment_sibling(SiblingAttachment siblingAttachment, EReference eReference) {

		// TimeMeasurement tm = new
		// TimeMeasurement("scope_SiblingAttachment_sibling "+siblingAttachment.getSiblingPosition());
		try {
			// tm.begin();
			LayoutData layoutData = getLayoutDataOfSiblingAttachment(siblingAttachment);
			GuiElement guiElement = (GuiElement) layoutData.getElementWithLayoutData();
			
			// GuiElement-siblings
			EObject containerOfSiblings = getContainerOfSiblings(guiElement);			
			List<EObject> siblings = getContainedGuiElements(containerOfSiblings);
			
			// TabulatorPosition siblings
			EObject containerOfComposeData = getContainerOfComposeData(guiElement);					
			if (containerOfComposeData != null) {
				ComposeData composeData = null;
				if (containerOfComposeData instanceof IComposite) {
					IComposite iComposite = (IComposite) containerOfComposeData;
					composeData = iComposite.getContent().getComposeLayout();
				}
				if (composeData != null) {
					List<TabulatorPosition> tabulators = composeData.getTabulators();
					for (TabulatorPosition tp : tabulators) {
						if (tp.getName() != null)
							siblings.add(tp);
					}
				}
			}
			// AttachementPosition siblings
			Page containingPage = PomElementCollector.getContainingPage(siblingAttachment);			
			Collection<AttachmentPosition> attachmentPositionsInScope = PomElementCollector.getInstance().getAccessibleAttachmentPositions(containingPage);
			siblings.addAll(attachmentPositionsInScope);			
			
			//return createSimpleScopeWithCustomNameResolving(siblings);						
			return new SimpleScope(Scopes.scopedElementsFor(siblings,customPomDslNameProvider));
		} finally {
			// tm.end();
		}
	}
	
	public IScope scope_TableColumn_attributeHolder(TableColumn tableColumn, EReference eReference) {
		DataObjectVariable object = tableColumn.getObject();
		if (object == null) {
			Table table = (Table) tableColumn.eContainer();
			object = table.getObject();
		}
		List<PresentableFeature> allAttributeHolders = object.getType().getAllPresentableFeaturesIncludingSuperType();
		return new SimpleScope(Scopes.scopedElementsFor(allAttributeHolders,domNameFunction));
	}

	public IScope scope_Table_key(Table table, EReference eReference) {
		List<PresentableFeature> allAttributeHolders = table.getObject().getType().getAllPresentableFeaturesIncludingSuperType();
		return new SimpleScope(Scopes.scopedElementsFor(allAttributeHolders,domNameFunction));			
	}

	/**
	 * Get all contained EObjects of namespace-container within its namespace
	 * 
	 * @param container
	 * @return
	 */
	public List<EObject> getNsElements(EObject container) {
		List<EObject> nsElements = new ArrayList<EObject>();
		addNsElements(container, nsElements);
		return nsElements;
	}

	private void addNsElements(EObject container, List<EObject> nsElements) {
		nsElements.addAll(container.eContents());
		for (EObject obj : container.eContents()) {
			if (isNsRangeBorder(obj) == false) {
				nsElements.addAll(getNsElements(obj));
			}
		}
	}
	
	/**
	 * Get all namespace elements of a Page. In case the page extends a super page
	 * the elements of the super page are added to the list of elements (at the 
	 * beginning of the list). This is done recursive.
	 * 
	 * @param page
	 * @return
	 */
	public static List<EObject> getNsElementsOfPage(Page page) {
		List<EObject> elems = getNsElementsInRange(page, null);			
		if (page instanceof XmadslPage) {
			XmadslPage xp = (XmadslPage)page;
			if (xp.getTemplate()!=null) {
				elems.addAll(0,getNsElementsOfPage(xp.getTemplate()));
			}
		}
		return elems; 			
	}
	
	/**
	 * Get the XMAPage which has the pageName in the given XMAComponent.
	 * 
	 * @param xmaComponent
	 * @param pageName
	 * @return
	 */
	public static XMAPage getXMAPageForNameInComponent(XMAComponent xmaComponent, String pageName) {
		
		if (pageName == null || pageName.length() == 0) return null;
		
		String namClass = Strings.capitalize(pageName);		

		Iterator it = xmaComponent.eAllContents();
		while (it.hasNext()) {
			Object no = it.next();
			if (no instanceof XMAPage) {
				XMAPage p = (XMAPage)no;
				if (p.getNamClass().equals(namClass)) {
					return p;
				}
			}
		}		
		return null;
	}
	
	public static LayoutData getLayoutDataOfSiblingAttachment(SiblingAttachment siblingAttachment) {	
		EObject siblingAttachmentContainer = siblingAttachment.eContainer();
		LayoutData layoutData = null;
		if (siblingAttachmentContainer instanceof AttachmentProperty) {
			AttachmentProperty attachment = (AttachmentProperty) siblingAttachment.eContainer();
			if (attachment.eContainer() instanceof IElementWithLayoutData == false) {
				layoutData = null;
			} else {
				layoutData = new LayoutData((IElementWithLayoutData) attachment.eContainer());
			}
		}	
		return layoutData;		
	}
	
	public static EObject getContainerOfSiblings(GuiElement guiElement) {
		EObject containerOfSiblings = null;
		if (guiElement.eContainer() instanceof SetOfGuiElements) {
			containerOfSiblings = guiElement.eContainer();
		} else {
			EObject c = PomElementCollector.getContainerWithComposeData(guiElement);
			containerOfSiblings = c;
		}		
		return containerOfSiblings;
	}
	
	public static EObject getContainerOfComposeData(GuiElement guiElement) {
		EObject containerOfComposeData = null;
		if (guiElement.eContainer() instanceof SetOfGuiElements) {
			EObject containerOfSiblings = guiElement.eContainer();
			containerOfComposeData = PomElementCollector.getContainerWithComposeData(containerOfSiblings);//containerOfSiblings.eContainer().eContainer();
		} else {
			EObject c = PomElementCollector.getContainerWithComposeData(guiElement);
			containerOfComposeData = c;
		}		
		return containerOfComposeData;
	}	

	/**
	 * Get all contained GuiElements of Composite
	 * 
	 * @param obj
	 * @return
	 */
	public static List<EObject> getContainedGuiElements(EObject obj) {
		List<EObject> guiElements = new ArrayList<EObject>();
		addContainedGuiElements(obj, guiElements);
		return guiElements;
	}

	private static void addContainedGuiElements(EObject obj, List<EObject> guiElements) {
		for (EObject child : obj.eContents()) {
			if (child instanceof GuiElement) {
				guiElements.add(child);
			}
			if (child instanceof Composite == false && child instanceof TabFolder == false) {
				addContainedGuiElements(child, guiElements);
			}
		}
	}

	public static Collection<EObject> getNsDataObjectVariable(Component component, Page page) {
		List<EObject> elements = getNsElementsInRange(component, page);
		return EcoreUtil.getObjectsByType(elements, PomPackage.eINSTANCE.getDataObjectVariable());
	}

	public static List<EObject> getNsElementsInRange(EObject topElement, final EObject bottomElement) {
		List<EObject> nsElements = new ArrayList<EObject>(topElement.eContents());
		List<EObject> elementsWithChildrenInNs = new ArrayList<EObject>();
		for (EObject eObject : nsElements) {
			if (isNsRangeBorder(eObject) == false || containsChildrenInRange(eObject, bottomElement)) {
				elementsWithChildrenInNs.add(eObject);
			}
		}
		for (EObject object : elementsWithChildrenInNs) {
			List<EObject> nsElementsInRange = getNsElementsInRange(object, bottomElement);
			nsElements.addAll(nsElementsInRange);
		}
		return nsElements;
	}

	private static boolean containsChildrenInRange(EObject element, EObject bottomElement) {
		return bottomElement != null ? element == bottomElement || org.eclipse.xtend.typesystem.emf.EcoreUtil2.allContents(element).contains(bottomElement)
				: false;
	}

	public static boolean isNsRangeBorder(EObject eObject) {
		if (eObject instanceof Page) {
			return true;
		} else if (eObject instanceof Component) {
			return true;
		} else if (eObject instanceof XMAPage) {
			return true;
		} else if (eObject instanceof XMAComponent) {
			return true;
		}
		return false;
	}

	
	/**
	 * Get the namespace container of the namespace which contains obj. In case
	 * no container is found the return value is null.
	 */ 		
	public EObject getNsContainer(EObject obj) {		
		if (obj instanceof CustomizationOfGuiElement) {
			CustomizationOfGuiElement customizationOfGuiElement = (CustomizationOfGuiElement)obj;
			return customizationOfGuiElement.getPage();
		}
		EObject container = obj.eContainer();
		if (isNsRangeBorder(container) || container == null) {
			return container;
		} else {
			return getNsContainer(container);
		}
	}	
	
	
}
